using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace m
{
    public class m
    {
        public static void Main()
        {



					 ModAPI.Register(
					    new Modification()
					    {
					        OriginalItem = ModAPI.FindSpawnable("Human"),
					        NameOverride = "Alien",
					        DescriptionOverride = "Oh... \nHERE UFO!",
					        CategoryOverride = ModAPI.FindCategory("Entities"),
					        ThumbnailOverride = ModAPI.LoadSprite("alienICON.png"),
					        AfterSpawn = (Instance) =>
					        {
					            var skin = ModAPI.LoadTexture("alienSKIN.png");
					            var flesh = ModAPI.LoadTexture("alienMEAT.png");
					            var bone = ModAPI.LoadTexture("alienSKELETON.png");

					            var person = Instance.GetComponent<PersonBehaviour>();

					            person.SetBodyTextures(skin, flesh, bone, 1);

					            var head = Instance.transform.Find("Head");
					            person.BoneBreakClips = new AudioClip[] { ModAPI.LoadSound("alien.wav") };

					            person.SetBruiseColor(89,173,53);
					            person.SetSecondBruiseColor(89,97,53);
					            person.SetThirdBruiseColor(89,51,53);
					            person.SetBloodColour(52,119,150);
					            person.SetRottenColour(97,87,147);
					            foreach (var body in person.Limbs)
					            {
					                body.transform.root.localScale *= 1.01f;
					            }
					        }
					    }
					);


	            ModAPI.Register(
	                new Modification()
	                {
	                    OriginalItem = ModAPI.FindSpawnable("Brick"),
	                    NameOverride = "UFO (prop)",
	                    NameToOrderByOverride = "1 1",
	                    DescriptionOverride = "Oh... \nHERE UFO!",
	                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
	                    ThumbnailOverride = ModAPI.LoadSprite("ffff_.png", 5f),
	                    AfterSpawn = (Instance) =>
	                    {
	                      	var childObject = new GameObject("the mf glow");
							childObject.transform.SetParent(Instance.transform);
							childObject.transform.localPosition = new Vector3(0f, 0f);
							childObject.transform.localScale = new Vector3(1f, 1f);
							var childSprite = childObject.AddComponent<SpriteRenderer>();
							childSprite.sprite = ModAPI.LoadSprite("ufo_.png");
							childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
							childSprite.sortingLayerName = "Top";

	                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ufo.png", 2f);
	                        Instance.FixColliders();
	                    }
	                }
	            );


            //Ufo
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Wheel"),
                    NameOverride = "Controllable UFO",
                    NameToOrderByOverride = "m 2",
                    DescriptionOverride = "Oh... \nHERE UFO!",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("da.png", 5f),
                    AfterSpawn = (Instance) =>
                    {                  
                    	var childObject = new GameObject("the mf glow");
						childObject.transform.SetParent(Instance.transform);
						childObject.transform.localPosition = new Vector3(0f, 0f);
						childObject.transform.localScale = new Vector3(1f, 1f);
						var childSprite = childObject.AddComponent<SpriteRenderer>();
						childSprite.sprite = ModAPI.LoadSprite("ufo_.png");
						childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						childSprite.sortingLayerName = "Top";

						bool control;
						control = true;

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ufo.png", 2f);
                        Instance.FixColliders();

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 500f; 
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 500f; 
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 500f;

                        Instance.GetComponent<Rigidbody2D>().freezeRotation = true;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.AddComponent<MainController>();
                        Instance.GetComponent<PhysicalBehaviour>().InitialGravityScale = 0f;
                        Instance.GetComponent<PhysicalBehaviour>().MakeWeightless();
                        Instance.GetComponent<Rigidbody2D>().velocity = Vector2.zero;
                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                            GameObject spawnedObj;
                            spawnedObj = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Alien").Prefab, Instance.transform.position, Quaternion.Euler(0, 0, 0));
                            CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Alien"), spawnedObj);
                            spawnedObj.transform.position = spawnedObj.transform.position + new Vector3(0f, -3f);
                            ModAPI.CreateParticleEffect("Spark", Instance.transform.position);



                        };
                    
                    }
                }
            );
        } 

        public class MainController : MonoBehaviour {

         public GameObject obj;

           public bool control;
        
            void Awake()
         {
         	this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("startbutt", "<color=yellow>- - - - - - -</color>", "<color=yellow>- - - - - - -</color>", () =>
            {
            }));

         	this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("Make Control", "<color=green>Control/Uncontrol", "<color=green>Make the UFO controllable", () =>
         	
            {
          	control = !control;

            }));

            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("endbutt", "<color=yellow>- - - - - - -</color>", "<color=yellow>- - - - - - -</color>", () =>
            {

            }));

         } 	
        
            void Update()
         {

         		if (!control) return;

                if (UnityEngine.Input.GetKey(UnityEngine.KeyCode.D)) //íàïðàâî
                    transform.Translate(5 * UnityEngine.Time.deltaTime, 0, 0);

                if (UnityEngine.Input.GetKey(UnityEngine.KeyCode.W)) //Âåðõ
                    transform.Translate(0, 5 * UnityEngine.Time.deltaTime, 0);                    

                if (UnityEngine.Input.GetKey(UnityEngine.KeyCode.A)) //íàëåâî
                    transform.Translate(-5 * UnityEngine.Time.deltaTime, 0, 0);

                if (UnityEngine.Input.GetKey(UnityEngine.KeyCode.S)) //íàëåâî
                    transform.Translate(0, -5*UnityEngine.Time.deltaTime, 0);
            }
        }
    }
}

   